Only in .: .depend
Only in ./config: Makefile.config
Only in ./config: confdefs.h
Only in ./config: config.h
Only in ./config: config.log
Only in ./config: config.status
Only in ./config: mldonkey.rc
Only in ./packages/rpm: Makefile
Only in ./packages/rpm: mldonkey.spec
Only in ./packages/windows: mlnet.nsi
Only in ./patches: build
Only in ./patches: local
Only in ./patches: ocaml-3.08.3.tar.gz
diff -u -r ../mldonkey-2.5.30.15/src/daemon/common/commonComplexOptions.ml ./src/daemon/common/commonComplexOptions.ml
--- ../mldonkey-2.5.30.15/src/daemon/common/commonComplexOptions.ml	2005-04-23 21:54:10.000000000 +0000
+++ ./src/daemon/common/commonComplexOptions.ml	2005-05-23 04:36:21.000000000 +0000
@@ -57,6 +57,8 @@
       match v with
         Options.Module assocs ->
           let get_value name conv = conv (List.assoc name assocs) in
+	   let num = try get_value "file_num" value_to_int (* get file_num from files.ini *)
+	   with _ -> 0 in
           let network = try get_value "file_network" value_to_string
             with _ -> "Donkey" in
           let network = network_find_by_name network in
@@ -100,6 +102,7 @@
         let netname = string_to_value (file_network file).network_name in
       let impl = as_file_impl file in
       Options.Module (
+        ("file_num", int_to_value (file_num file)) :: (* adds file_num entry to files section in files.ini *)
         ("file_network", netname) ::
         ("file_size", int64_to_value (file_size file)) ::
         ("file_priority", int_to_value (file_priority file)) ::
Only in ./src/daemon/common: commonDownloads.ml
diff -u -r ../mldonkey-2.5.30.15/src/daemon/common/commonFile.ml ./src/daemon/common/commonFile.ml
--- ../mldonkey-2.5.30.15/src/daemon/common/commonFile.ml	2005-04-24 19:44:16.000000000 +0000
+++ ./src/daemon/common/commonFile.ml	2005-05-23 04:33:01.000000000 +0000
@@ -170,14 +170,20 @@
       CommonEvent.add_event (File_info_event file);
     end
 
-let update_file_num impl =
-  if impl.impl_file_num = 0 then begin
-      incr file_counter;
-      impl.impl_file_num <- !file_counter;
-      H.add files_by_num (as_file impl);
-      file_must_update (as_file impl);
-    end
-    
+(*sets the file number of all files for hashtable H*)
+  let update_file_num impl =
+   if impl.impl_file_num = 0 then
+       begin
+        incr file_counter;
+        impl.impl_file_num <- !file_counter;
+       end
+   else if impl.impl_file_num > !file_counter then
+       begin
+	file_counter := impl.impl_file_num;
+       end;
+   H.add files_by_num (as_file impl);
+   file_must_update (as_file impl);; (* needed even if the file_num wasn't updated?? *)
+     
     
 let update_file_state impl state =
   impl.impl_file_state <- state;
Only in ./src/daemon/common: commonGraphics.ml
Only in ./src/daemon/common: giftLexer.ml
Only in ./src/daemon/common: giftParser.ml
Only in ./src/daemon/common: giftParser.mli
diff -u -r ../mldonkey-2.5.30.15/src/networks/donkey/donkeyComplexOptions.ml ./src/networks/donkey/donkeyComplexOptions.ml
--- ../mldonkey-2.5.30.15/src/networks/donkey/donkeyComplexOptions.ml	2005-04-24 19:44:16.000000000 +0000
+++ ./src/networks/donkey/donkeyComplexOptions.ml	2005-05-23 04:43:13.000000000 +0000
@@ -269,7 +269,7 @@
   let get_value_nil name conv = 
     try conv (List.assoc name assocs) with _ -> []
   in
-  
+  let file_num = get_value "file_num" value_to_int in
   let file_md4 = 
     try
       get_value "file_md4" value_to_string
@@ -312,7 +312,7 @@
   let filenames = List.map (fun name -> name, GuiTypes.noips()) 
     (get_value_nil "file_filenames" (value_to_list value_to_string)) in
   
-  let file = DonkeyGlobals.new_file file_diskname file_state
+  let file = DonkeyGlobals.new_file file_diskname file_num file_state
     (Md4.of_string file_md4) file_size filenames true in
 
   (*
diff -u -r ../mldonkey-2.5.30.15/src/networks/donkey/donkeyGlobals.ml ./src/networks/donkey/donkeyGlobals.ml
--- ../mldonkey-2.5.30.15/src/networks/donkey/donkeyGlobals.ml	2005-04-26 11:02:21.000000000 +0000
+++ ./src/networks/donkey/donkeyGlobals.ml	2005-05-23 04:40:10.000000000 +0000
@@ -283,7 +283,7 @@
     with Not_found -> ()
 
         
-let new_file file_diskname file_state md4 file_size filenames writable =
+let new_file file_diskname file_num file_state md4 file_size filenames writable =
   
   try
       let file = find_file md4 in
@@ -366,6 +366,7 @@
       and file_impl = {
           dummy_file_impl with
           impl_file_val = file;
+	  impl_file_num = file_num;
           impl_file_ops = file_ops;
           impl_file_age = last_time ();          
           impl_file_size = file_size;
diff -u -r ../mldonkey-2.5.30.15/src/networks/donkey/donkeyInteractive.ml ./src/networks/donkey/donkeyInteractive.ml
--- ../mldonkey-2.5.30.15/src/networks/donkey/donkeyInteractive.ml	2005-04-26 11:02:21.000000000 +0000
+++ ./src/networks/donkey/donkeyInteractive.ml	2005-05-23 04:38:46.000000000 +0000
@@ -159,7 +159,7 @@
     (List.map (fun name -> name , { ips=[]; nips=0}) filenames)
   in
 
-  let file = new_file file_diskname FileDownloading md4 size filenames true in
+  let file = new_file file_diskname 0 FileDownloading md4 size filenames true in
   begin
     match absents with
       None -> ()
diff -u -r ../mldonkey-2.5.30.15/src/networks/donkey/donkeyShare.ml ./src/networks/donkey/donkeyShare.ml
--- ../mldonkey-2.5.30.15/src/networks/donkey/donkeyShare.ml	2005-05-02 12:57:59.000000000 +0000
+++ ./src/networks/donkey/donkeyShare.ml	2005-05-23 04:41:20.000000000 +0000
@@ -88,7 +88,7 @@
     lprintf "Sharing file with MD4: %s\n" (Md4.to_string md4);
     end;
     
-    let file = new_file sh.sh_name FileShared md4 sh.sh_size
+    let file = new_file sh.sh_name 0 FileShared md4 sh.sh_size
         [Filename.basename sh.sh_name, GuiTypes.noips()]
         false in
     must_share_file file codedname old_impl;
Only in ./src/networks/fasttrack: fasttrackClients.ml
Only in ./src/networks/fasttrack: fasttrackComplexOptions.ml
Only in ./src/networks/fasttrack: fasttrackFunctions.ml
Only in ./src/networks/fasttrack: fasttrackInteractive.ml
Only in ./src/networks/fasttrack: fasttrackMain.ml
Only in ./src/networks/fasttrack: fasttrackOptions.ml
Only in ./src/networks/fasttrack: fasttrackTypes.ml
Only in ./src/networks/gnutella2: g2Clients.ml
Only in ./src/networks/gnutella2: g2ComplexOptions.ml
Only in ./src/networks/gnutella2: g2Functions.ml
Only in ./src/networks/gnutella2: g2Globals.ml
Only in ./src/networks/gnutella2: g2Interactive.ml
Only in ./src/networks/gnutella2: g2Main.ml
Only in ./src/networks/gnutella2: g2Options.ml
Only in ./src/networks/gnutella2: g2Protocol.ml
Only in ./src/networks/gnutella2: g2Servers.ml
Only in ./src/networks/gnutella2: g2Types.ml
Only in ./src/networks/opennap: napigator.ml
Only in ./src/utils/lib: autoconf.ml
Only in ./src/utils/lib: autoconf.ml.new
Only in ./src/utils/lib: cddb_lexer.ml
Only in ./src/utils/lib: gAutoconf.ml
Only in ./src/utils/lib: gAutoconf.ml.new
Only in ./src/utils/lib: gettext.ml
Only in ./src/utils/lib: http_lexer.ml
Only in ./src/utils/lib: options.ml
Only in ./src/utils/xml-light: xml_lexer.ml
Only in ./src/utils/xml-light: xml_parser.ml
Only in ./src/utils/xml-light: xml_parser.mli
Only in ./tools: ocamlpp.ml
Only in ./tools/zoggy: pa_zog.cmi
Only in ./tools/zoggy: pa_zog.cmo
Only in ./tools/zoggy: zog_messages.cmi
Only in ./tools/zoggy: zog_messages.cmo
Only in ./tools/zoggy: zog_misc.cmi
Only in ./tools/zoggy: zog_misc.cmo
Only in ./tools/zoggy: zog_types.cmi
Only in ./tools/zoggy: zog_types.cmo